<?php
class pluginTwitchEmbed extends Plugin {
    public function init()
    {
        $this->dbFields = array();
    }
    public function siteHead()
    {
        echo '<style>
                .twitch-embed {
                    position: relative;
                    padding-bottom: 56.25%;
                    height: 0;
                    overflow: hidden;
                    margin-bottom: 10px;
                }
                .twitch-embed iframe {
                    position: absolute;
                    top: 0;
                    left: 0;
                    width: 100%;
                    height: 100%;
                }
              </style>';
    }
    public function siteBodyEnd() {
        echo <<<HTML
        <script src="https://player.twitch.tv/js/embed/v1.js"></script>
        <script>
        document.addEventListener("DOMContentLoaded", function() {
            function processNode(node) {
                if (node.nodeType === 3) {
                    var parent = node.parentNode;
                    var text = node.nodeValue;
                    var regex = /\\[twitch=(.*?)\\]/g;
                    var match = regex.exec(text);
                    if (match) {
                        var before = document.createTextNode(text.slice(0, match.index));
                        var embedDiv = document.createElement('div');
                        embedDiv.className = 'twitch-embed';
                        var embedId = 'twitch-embed-' + match[1];
                        embedDiv.id = embedId;
                        parent.insertBefore(before, node);
                        parent.insertBefore(embedDiv, node);
                        var after = document.createTextNode(text.slice(regex.lastIndex));
                        parent.insertBefore(after, node);
                        parent.removeChild(node);
                        new Twitch.Player(embedId, {
                            channel: match[1]
                        });
                    }
                } else if (node.nodeType === 1) {
                    for (var i = 0; i < node.childNodes.length; i++) {
                        processNode(node.childNodes[i]);
                    }
                }
            }
            processNode(document.body);
        });
        </script>
        HTML;
    }
}